import { BaseContract } from "../base-contract.js";
import { v2RouterAddress, v2RouterAbi } from "../config/v2routerconfig.js";

class v2RouterContract extends BaseContract  {
    constructor(address = null){ 
		super(address ?? v2RouterAddress, v2RouterAbi);		
    }

    async amountsOut(amountIn, path){
        if(this.contract){
            return this.contract.getAmountsOut(amountIn, path);
        }
    }

    async SwapEthForToken(account, amountIn, amountOutMin, path)
    {
        if(this.contract){
            let options = { value: amountIn }
            return this.contract
                    .connect(this.provider.getSigner())
                    .swapExactETHForTokens(
                        amountOutMin,
                        path,
                        account,
                        Math.floor(Date.now() / 1000) + (60 * 10),
                        options
                    );
        }
    }

    async SwapTokenForEth(account, amountIn, amountOutMin, path)
    {
        if(this.contract){
            return this.contract
                .connect(this.provider.getSigner())
                .swapExactTokensForETH(
                    amountIn,
                    amountOutMin,
                    path,
                    account,
                    Math.floor(Date.now() / 1000) + (60 * 10)
            );
        }
    }

    async SwapTokenForEthwFee(account, amountIn, amountOutMin, path)
    {
        console.log("Swapping token for eth");
        if(this.contract){
            return this.contract
                .connect(this.provider.getSigner())
                .swapExactTokensForETHSupportingFeeOnTransferTokens(
                    amountIn,
                    amountOutMin,
                    path,
                    account,
                    Math.floor(Date.now() / 1000) + (60 * 10)
            );
        }
    }
}

export { v2RouterContract }